//+------------------------------------------------------------------+
//|                                          colored macd            |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"


#property indicator_separate_window
#property indicator_buffers    2
#property indicator_color1     Green
#property indicator_color2     Red
#property indicator_width1     4
#property indicator_width2     4
#property indicator_levelcolor DarkSlateGray

//
//
//
//
//

extern int    NlmPeriod       = 34;
extern int    NlmPrice        = PRICE_CLOSE;
extern double PctFilter       = 0;
extern string note            = "turn on Alert = true; turn off = false";
extern bool   alertsOn        = false;
extern bool   alertsOnSlope   = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsEmail     = false;
extern string soundfile       = "alert2.wav";

//
//
//
//
//

double Upa[];
double Dna[];
double diff[];
double slope[];
double nlm[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,Upa);   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,Dna);   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,diff);
   SetIndexBuffer(3,nlm);
   SetIndexBuffer(4,slope);
   SetLevelValue(0,0);
   IndicatorShortName("Nlma Slope");
return(0);
}
               
//
//
//
//
//

int deinit() { return(0);}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
     
      double pipValue = Point; if (Digits ==3 || Digits ==5) pipValue *= 10;
      for(i=limit; i>=0; i--) 
      {
         nlm[i]   = iNonLagMa(iMA(NULL,0,1,0,MODE_SMA,NlmPrice,i),NlmPeriod,i,0);
         diff[i]  = (nlm[i]-nlm[i+1])/pipValue;
         Upa[i]   = EMPTY_VALUE;
         Dna[i]   = EMPTY_VALUE;
         slope[i] = slope[i+1];

            if (diff[i] > 0) slope[i] =  1;
            if (diff[i] < 0) slope[i] = -1;
            if (slope[i]== 1) Upa[i]  = diff[i];
            if (slope[i]==-1) Dna[i]  = diff[i];
      }
      
      //
      //
      //
      //
      //
      
      if (alertsOn)
      {
          if (alertsOnCurrent)
               int whichBar = 0;
          else     whichBar = 1;
         
          if (slope[whichBar] != slope[whichBar+1])
          if (slope[whichBar] == 1)
                doAlert("Buy");
          else  doAlert("Sell");       
   }
   return(0);            
}
  
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Nonlag Ma Slope ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Nonlag Ma Slope "),message);
             if (alertsSound)   PlaySound(soundfile);
      }
}
      
//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

#define Pi       3.14159265358979323846264338327950288
#define _length  0
#define _len     1
#define _weight  2

double  nlmvalues[1][3];
double  nlmprices[ ][1];
double  nlmalphas[ ][1];

//
//
//
//
//

double iNonLagMa(double price, double length, int r, int instanceNo=0)
{
   r = Bars-r-1;
   if (ArrayRange(nlmprices,0) != Bars)         ArrayResize(nlmprices,Bars);
   if (ArrayRange(nlmvalues,0) <  instanceNo+1) ArrayResize(nlmvalues,instanceNo+1);
                               nlmprices[r][instanceNo]=price;
   if (length<3 || r<3) return(nlmprices[r][instanceNo]);
   
   //
   //
   //
   //
   //
   
   if (nlmvalues[instanceNo][_length] != length  || ArraySize(nlmalphas)==0)
   {
      double Cycle = 4.0;
      double Coeff = 3.0*Pi;
      int    Phase = length-1;
      
         nlmvalues[instanceNo][_length] = length;
         nlmvalues[instanceNo][_len   ] = length*4 + Phase;  
         nlmvalues[instanceNo][_weight] = 0;

         if (ArrayRange(nlmalphas,0) < nlmvalues[instanceNo][_len]) ArrayResize(nlmalphas,nlmvalues[instanceNo][_len]);
         for (int k=0; k<nlmvalues[instanceNo][_len]; k++)
         {
            if (k<=Phase-1) 
                 double t = 1.0 * k/(Phase-1);
            else        t = 1.0 + (k-Phase+1)*(2.0*Cycle-1.0)/(Cycle*length-1.0); 
            double beta = MathCos(Pi*t);
            double g = 1.0/(Coeff*t+1); if (t <= 0.5 ) g = 1;
      
            nlmalphas[k][instanceNo]        = g * beta;
            nlmvalues[instanceNo][_weight] += nlmalphas[k][instanceNo];
         }
   }
   
   //
   //
   //
   //
   //
   
   if (nlmvalues[instanceNo][_weight]>0)
   {
      double sum = 0;
           for (k=0; k < nlmvalues[instanceNo][_len]; k++) sum += nlmalphas[k][instanceNo]*nlmprices[r-k][instanceNo];
           return( sum / nlmvalues[instanceNo][_weight]);
   }
   else return(0);           
}